package net.javajigi.abs;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Random;

import net.javajigi.db.ConnectionManager;

public class AirplaneCreate {
	Random rnd = null;
	
	public AirplaneCreate() {
		rnd = new Random();
	}
		
	public int getSeatNo(){
		while(true){
			long result = (rnd.nextLong()) % 1000;
			long result2 = Math.abs(result);
			if ( (result2 > 100) && ( result2 < 200) ){
				return (new Long(result2)).intValue();
			}
		}
	}

	
	public boolean existedCode(int airplaneCode) throws SQLException {
		String query = 
			"select count(*) from airplane where airplanecode=?";
			
		Connection con = ConnectionManager.getConnection();
		PreparedStatement pstmt = con.prepareStatement(query);
		pstmt.setInt(1, airplaneCode);
		
		ResultSet rs = pstmt.executeQuery();
		
		rs.next();
		
		int count = rs.getInt(1);
		
		rs.close();
		pstmt.close();
		con.close();
		
		if ( count > 0 ) {
			return true;
		} else {
			return false;
		}			
	}
		
	public static void main(String[] args) {
		AirplaneCreate create = new AirplaneCreate();		

		try {
			String query = 
				"select airplanecode from schedulecode";
			
			Connection con = ConnectionManager.getConnection();
			PreparedStatement pstmt = con.prepareStatement(query);

			ResultSet rs = pstmt.executeQuery();
			
			String query2 = 
				"insert into airplane values(?, ?)";
				
			Connection con2 = ConnectionManager.getConnection();				
			PreparedStatement pstmt2 = con2.prepareStatement(query2);
			
			int result = 0;
			
			while( rs.next() ){
				int code = rs.getInt("airplanecode");
				
				if ( !create.existedCode(code) ){
					pstmt2.setInt(1, code);
					pstmt2.setInt(2, create.getSeatNo());
				
					result += pstmt2.executeUpdate();				
				}				
			}
			
			pstmt2.close();
			con2.close();
			
			rs.close();			
			pstmt.close();
			con.close();			
		} catch ( SQLException e ){
			System.out.println("Exception is created : " + e.getMessage());
		}	
		
	}
}
