package net.javajigi.abs.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.abs.form.ScheduleForm;
import net.javajigi.abs.model.AirBookingService;
import net.javajigi.abs.model.ScheduleInfoList;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/** 
 * @struts.action
 *      name="scheduleForm"
 *      path="/scheduleInfoList"
 *      input="/airplane1.jsp"
 *      scope="request"
 *      validate="false"
 *
 * @struts.action-forward
 *      name="searchResult"
 *      path="/airplane2.jsp"
 */
public class ScheduleInfoListAction extends Action {

	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		ScheduleForm scheduleForm = (ScheduleForm) form;
		String date =
			scheduleForm.getYear()
				+ scheduleForm.getMonth()
				+ scheduleForm.getDay();

		AirBookingService abs = AirBookingService.getInstance();
		ScheduleInfoList infoList =
			abs.getScheduleInfoList(
				date,
				scheduleForm.getTime(),
				scheduleForm.getStartCity(),
				scheduleForm.getArriveCity());
		
		request.setAttribute("result", infoList);

		return mapping.findForward("searchResult");
	}
}
