package net.javajigi.abs.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import net.javajigi.abs.Constants;
import net.javajigi.abs.form.ScheduleUserInfoForm;
import net.javajigi.abs.model.AirBookingService;
import net.javajigi.abs.model.ScheduleInfo;
import net.javajigi.abs.model.ScheduleOrder;
import net.javajigi.abs.model.UserInfo;
import net.javajigi.user.model.User;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/** 
 * @struts.action
 * 		name="scheduleUserInfoForm"
 *      path="/viewScheduleOrder"
 *      input="/airplane3.jsp"
 *      scope="request"
 *      validate="false"
 *
 * @struts.action-forward
 *      name="success"
 *      path="/airplane4.jsp"
 */
public class ViewScheduleOrderAction extends SignonAction {
	public ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		ScheduleUserInfoForm scheduleUserInfo = (ScheduleUserInfoForm) form;
		User user = getUser(request);
		
		UserInfo userInfo = new UserInfo();
		userInfo.setUserId(user.getUserId());
		userInfo.setName(user.getName());
		userInfo.setEmail(scheduleUserInfo.getEmail());
		userInfo.setPhoneNo(scheduleUserInfo.getPhoneNo());

		AirBookingService abs = AirBookingService.getInstance();
		ScheduleInfo scheduleInfo =
			abs.getScheduleInfo(
				scheduleUserInfo.getScheduleCode(),
				scheduleUserInfo.getDate());
				
		ScheduleOrder order = new ScheduleOrder();
		order.setScheduleInfo(scheduleInfo);
		order.setUserInfo(userInfo);
		order.setScheduleSeatNo(scheduleUserInfo.getPassengerNo());	
			
		HttpSession session = request.getSession();
		
		if ( session.getAttribute(Constants.ORDER_NO) == null ){
			order = abs.createScheduleOrder(order);
		}		
		
		if ( order != null ){
			//ǿ ֹȣ.			
			session.setAttribute(Constants.ORDER_NO, new Integer(order.getOrderNo()));				
		}		

		request.setAttribute("scheduleOrder", order);

		return mapping.findForward("success");
	}
}
