package net.javajigi.abs.model;

import java.sql.SQLException;
import java.text.ParseException;

/**
 * װ  񽺸  ̽ ϰ ִ Ŭ.
 * ScheduleDAO OrderDAO    Ŭ ϰ ִ.
 * ڵ װ  񽺸   Ŭ ̿ϰ ȴ.
 */
public class AirBookingService {
	private AirBookingService() {
	}

	public static AirBookingService getInstance() {
		return new AirBookingService();
	}

	public ScheduleOrder createScheduleOrder(ScheduleOrder scheduleOrder)
		throws SQLException {
		ScheduleInfo scheduleInfo = scheduleOrder.getScheduleInfo();

		PlaneSchedule schedule = new PlaneSchedule();
		schedule.setScheduleCode(scheduleInfo.getScheduleCode());
		schedule.setScheduleDate(scheduleInfo.getDate());
		schedule.setReserveSeatNo(scheduleOrder.getScheduleSeatNo());

		int result = getScheduleDAO().modifyPlaneSchedule(schedule);

		if (result == 0) {
			int airPlaneCode =
				getScheduleDAO().getAirplaneCode(
					scheduleInfo.getScheduleCode());
			schedule.setRestNo(
				getScheduleDAO().getSeatNo(airPlaneCode)
					- scheduleOrder.getScheduleSeatNo());

			getScheduleDAO().createPlaneSchedule(schedule);
		}

		return getOrderDAO().createScheduleOrder(scheduleOrder);
	}

	public int createPlaneOrder(PlaneOrder planeOrder) throws SQLException {

		return getOrderDAO().createPlaneOrder(planeOrder);
	}

	public ScheduleOrder findScheduleOrder(int orderNo) throws SQLException {

		return getOrderDAO().findScheduleOrder(orderNo);
	}

	public ScheduleInfoList getScheduleInfoList(
		String date,
		int time,
		String startCity,
		String arriveCity)
		throws ParseException, SQLException {
		ScheduleInfoList infoList = new ScheduleInfoList();
		infoList.setDate(date);
		infoList.setStartCity(startCity);
		infoList.setArriveCity(arriveCity);
		infoList.setScheduleInfos(
			getScheduleDAO().getScheduleInfos(
				date,
				time,
				startCity,
				arriveCity));

		return infoList;
	}

	public ScheduleInfo getScheduleInfo(int scheduleCode, String date)
		throws SQLException {

		return getScheduleDAO().getScheduleInfo(scheduleCode, date);
	}

	private ScheduleDAO getScheduleDAO() {
		return new ScheduleDAO();
	}

	private OrderDAO getOrderDAO() {
		return new OrderDAO();
	}
}
