package net.javajigi.abs.model;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import net.javajigi.db.ConnectionManager;
import net.javajigi.util.DateTime;

public class OrderDAO {
	/**
	 * SCHEDULEORDER̺ ӽ   ϴ ޽.
	 * ӽ÷       Ȱȴ.
	 */
	public ScheduleOrder createScheduleOrder(ScheduleOrder scheduleOrder)
		throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		try {
			StringBuffer selectQuery = new StringBuffer();
			selectQuery.append("INSERT INTO SCHEDULEORDER ");
			selectQuery.append("VALUES ");
			selectQuery.append("(?, ?, ?, ?, ?, ?, ?, ?, ?)");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(selectQuery.toString());

			scheduleOrder.setOrderNo(findOrderNo());
			pstmt.setInt(1, scheduleOrder.getOrderNo());
			UserInfo userInfo = scheduleOrder.getUserInfo();
			pstmt.setString(2, userInfo.getUserId());
			pstmt.setString(3, userInfo.getName());
			pstmt.setString(4, userInfo.getEmail());
			pstmt.setString(5, userInfo.getPhoneNo());
			ScheduleInfo scheduleInfo = scheduleOrder.getScheduleInfo();
			pstmt.setString(6, scheduleInfo.getDate());
			pstmt.setInt(7, scheduleInfo.getScheduleCode());
			pstmt.setInt(8, scheduleOrder.getScheduleSeatNo());
			pstmt.setInt(9, scheduleOrder.getTotalFee());

			pstmt.executeUpdate();

			return scheduleOrder;
		} finally {
			close(con, pstmt);
		}
	}

	public int removeScheduleOrder(int orderNo)
		throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		try {
			StringBuffer removeQuery = new StringBuffer();
			removeQuery.append("DELETE FROM SCHEDULEORDER ");
			removeQuery.append("WHERE orderno = ?");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(removeQuery.toString());
			pstmt.setInt(1, orderNo);

			return pstmt.executeUpdate();
		} finally {
			if (pstmt != null) {
				pstmt.close();
			}
			if (con != null) {
				con.close();
			}
		}
	}


	/**
	 *   ϷǾ  PLANEORDER̺ 
	 *   ϴ ޽. 
	 */
	public int createPlaneOrder(PlaneOrder planeOrder)
		throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		try {
			StringBuffer selectQuery = new StringBuffer();
			selectQuery.append("INSERT INTO PLANEORDER ");
			selectQuery.append("VALUES ");
			selectQuery.append("(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ");
			selectQuery.append("?, ?, ?, ?, ?, ?, ?)");
			
			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(selectQuery.toString());

			pstmt.setInt(1, planeOrder.getOrderNo());
			UserInfo userInfo = planeOrder.getUserInfo();
			pstmt.setString(2, userInfo.getUserId());
			pstmt.setString(3, userInfo.getName());
			pstmt.setString(4, userInfo.getEmail());
			pstmt.setString(5, userInfo.getPhoneNo());
			ScheduleInfo scheduleInfo = planeOrder.getScheduleInfo();
			pstmt.setString(6, scheduleInfo.getDate());
			pstmt.setInt(7, scheduleInfo.getScheduleCode());
			pstmt.setInt(8, planeOrder.getScheduleSeatNo());
			pstmt.setInt(9, planeOrder.getTotalFee());
			CreditCardInfo creditCardInfo = planeOrder.getCreditCardInfo();
			pstmt.setString(10, creditCardInfo.getCreditCardName());
			pstmt.setString(11, creditCardInfo.getCardNo());
			pstmt.setString(12, creditCardInfo.getCreditExpireDate());
			pstmt.setString(13, creditCardInfo.getJuminNo());
			pstmt.setString(14, creditCardInfo.getCardPassword());
			pstmt.setInt(15, creditCardInfo.getPayPlan());
			pstmt.setString(16, creditCardInfo.getCardOwnerName());
			pstmt.setString(17, DateTime.getDateTimeString());

			int result = pstmt.executeUpdate();

			removeScheduleOrder(planeOrder.getOrderNo());
			
			return result;
		} finally {
			close(con, pstmt);
		}
	}


	private int findOrderNo() throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			StringBuffer selectQuery = new StringBuffer();
			selectQuery.append("SELECT ");
			selectQuery.append("max(orderno) ");
			selectQuery.append("FROM SCHEDULEORDER");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(selectQuery.toString());

			rs = pstmt.executeQuery();
			rs.next();

			int orderNo = rs.getInt(1);

			if (orderNo == 0) {
				return 10000;
			} else {
				return orderNo + 1;
			}
		} finally {
			close(con, pstmt, rs);
		}
	}

	/**
	 * SCHEDULEORDER̺ ӽ    ScheduleOrderü
	 * Ͽ ȯϴ ޽.
	 */
	public ScheduleOrder findScheduleOrder(int orderNo) throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			StringBuffer selectQuery = new StringBuffer();
			selectQuery.append("SELECT ");
			selectQuery.append("userid, name, email, phoneno, scheduledate, ");
			selectQuery.append("schedulecode, scheduleseatno, totalfee ");
			selectQuery.append("FROM SCHEDULEORDER ");
			selectQuery.append("WHERE orderno = ? ");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(selectQuery.toString());
			pstmt.setInt(1, orderNo);

			rs = pstmt.executeQuery();
			if (rs.next()) {
				ScheduleOrder scheduleOrder = new ScheduleOrder();
				scheduleOrder.setOrderNo(orderNo);
				scheduleOrder.setScheduleSeatNo(rs.getInt("scheduleseatno"));
				scheduleOrder.setTotalFee(rs.getInt("totalfee"));

				UserInfo userInfo = new UserInfo();
				userInfo.setUserId(rs.getString("userid"));
				userInfo.setName(rs.getString("name"));
				userInfo.setEmail(rs.getString("email"));
				userInfo.setPhoneNo(rs.getString("phoneno"));
				scheduleOrder.setUserInfo(userInfo);

				ScheduleDAO scheduleDAO = new ScheduleDAO();
				ScheduleInfo scheduleInfo =
					scheduleDAO.getScheduleInfo(
						rs.getInt("schedulecode"),
						rs.getString("scheduledate"));
				scheduleOrder.setScheduleInfo(scheduleInfo);
				
				return scheduleOrder;
			} else {
				return null;
			}
		} finally {
			close(con, pstmt, rs);
		}
	}

	public PlaneOrder findPlaneOrder(int orderNo) throws SQLException {
		return null;
	}

	private void close(Connection con, PreparedStatement pstmt, ResultSet rs)
		throws SQLException {
		if (rs != null) {
			rs.close();
		}

		close(con, pstmt);
	}

	private void close(Connection con, PreparedStatement pstmt)
		throws SQLException {
		if (pstmt != null) {
			pstmt.close();
		}

		if (con != null) {
			con.close();
		}
	}
}
