package net.javajigi.petstore.action.cart;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.petstore.action.BaseAction;
import net.javajigi.petstore.model.Cart;
import net.javajigi.petstore.model.domain.Customer;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author <a href="mailto:tchbansi@sourceforge.net">Herve Tchepannou</a>
 *
 * @struts.action
 *      name="cartForm"
 *      path="/checkout"
 *      scope="request"
 *      validate="false"
 *
 * @struts.action-forward
 *      name="success"
 *      path="/checkout.jsp"
 */
public class CheckoutAction extends BaseAction {

	protected ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		String userId = (String) request.getSession().getAttribute(USERID_KEY);
		CartForm frm = (CartForm) form;
		Cart cart = getCart(request);

		/* Order */
		Customer cust = getPetstore().getCustomer(userId);
		frm.setCustomerValue(cust);

		/* Cart items */
		Collection items = cart.getCartItems();
		frm.setCartItems(items);

		/* Total */
		frm.setTotal(cart.getTotal());

		return mapping.findForward(SUCCESS);
	}
}
