package net.javajigi.petstore.action.order;

import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.petstore.action.BaseAction;
import net.javajigi.petstore.model.Cart;
import net.javajigi.petstore.model.PetStore;
import net.javajigi.util.DateTime;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @struts.action
 *      name="orderForm"
 *      path="/createOrder"
 *      scope="request"
 *      validate="false"
 *
 * @struts.action-forward
 *      name="success"
 *      path="/confirmation.jsp"
 */
public class CreateOrderAction extends BaseAction {
	protected ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		OrderForm frm = (OrderForm) form;
		String userId = (String) request.getSession().getAttribute(USERID_KEY);
		PetStore petstore = getPetstore();

		/* Proceed the order */
		HashMap items = new HashMap();

		for (int i = 0, len = frm.getItemId().length; i < len; i++) {
			items.put(frm.getItemId()[i], new Integer(frm.getQuantity()[i]));
		}

		long orderId =	petstore.createOrder(userId, DateTime.getDateTimeString(), items);
		
		frm.getOrderValue().setOrderId(orderId);

		/* Invalidating the current cart */
		Cart cart = getCart(false, request);

		if (cart != null) {
			request.getSession().removeAttribute(CART_KEY);
		}

		return mapping.findForward(SUCCESS);
	}
}
