package net.javajigi.petstore.action.product;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.petstore.action.BaseAction;
import net.javajigi.petstore.model.PetStore;
import net.javajigi.petstore.model.domain.Product;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author <a href="mailto:tchbansi@sourceforge.net">Herve Tchepannou</a>
 *
 * @struts.action
 *      name="productForm"
 *      path="/product"
 *      scope="request"
 *      validate="false"
 *
 * @struts.action-forward
 *      name="success"
 *      path="/product.jsp"
 */
public class ProductAction extends BaseAction {

	protected ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		ProductForm frm = (ProductForm) form;
		String productId = frm.getProductId();
		PetStore petstore = getPetstore();

		/* Product */
		Product product = petstore.getProduct(productId);
		frm.setProductValue(product);

		return mapping.findForward(SUCCESS);
	}
}
