package net.javajigi.petstore.action.signon;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.petstore.action.BaseAction;
import net.javajigi.petstore.model.PetStore;
import net.javajigi.petstore.model.domain.Account;
import net.javajigi.petstore.model.domain.Customer;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @struts.action
 *      name="signonForm"
 *      path="/login"
 *      input="/signon.jsp"
 *      scope="request"
 *      validate="true"
 *
 * @struts.action-forward
 *      name="success"
 *      path="/index.jsp"
 *
 * @struts.action-forward
 *      name="error"
 *      path="/signon.jsp"
 */
public class LoginAction extends BaseAction {
	public ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		SignonForm frm = (SignonForm) form;
		Account account = frm.getAccountValue();
		String redirectUri = frm.getRedirectUri();
		PetStore petstore = getPetstore();

		if (petstore
			.authenticate(account.getUserId(), account.getPassword())) {
			Customer cust = petstore.getCustomer(account.getUserId());
			initSession(cust, request);

			if ((redirectUri == null) || (redirectUri.length() == 0)) {
				return mapping.findForward(SUCCESS);
			} else {
				_log.info("...redirecting to: " + redirectUri);
				response.sendRedirect(redirectUri);
				return null;
			}
		} else {
			request.setAttribute(
				MESSAGE_KEY,
				getString("authentication_failed"));

			return mapping.findForward(ERROR);
		}
	}
}
