package net.javajigi.petstore.model;

import net.sf.hibernate.Session;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import edu.arbor.util.plugin.HibernatePlugIn;

public class BasePetStoreDAO {
    private Log log = LogFactory.getLog( BasePetStoreDAO.class );

    protected void delete(Class clazz, String id) throws Exception {
      Session ses = HibernatePlugIn.openSession();
      try {
        Object obj = ses.load(clazz, id);
        ses.delete(obj);
        ses.flush();
        ses.connection().commit();
      } catch (Exception e) {
        log.error(" Error deleting object", e);
        ses.connection().rollback();
        throw e;
      } finally {
        HibernatePlugIn.closeSession();
      }
    }

    protected void delete(Class clazz, Integer id) throws Exception {
      Session ses = HibernatePlugIn.openSession();
      try {
        Object obj = ses.load(clazz, id);
        ses.delete(obj);
        ses.flush();
        ses.connection().commit();
      } catch (Exception e) {
          log.error(" Error deleting object", e);
          ses.connection().rollback();
          throw e;
      } finally {
        HibernatePlugIn.closeSession();
      }
    }

    protected Object retrieve(Class clazz, String id) throws Exception {
      Session ses = HibernatePlugIn.openSession();
      Object obj = null;
      try {
          obj = ses.load(clazz, id);
      } catch (Exception e) {
          log.error(" Error retrieving object", e);
          throw e;
      } finally {
        HibernatePlugIn.closeSession();
      }
      return obj;
    }

    protected Object retrieve(Class clazz, Integer id) throws Exception {
      Session ses = HibernatePlugIn.openSession();
      Object obj = null;
      try {
          obj = ses.load(clazz, id);
      } catch (Exception e) {
          log.error(" Error retrieving object", e);
          throw e;
      } finally {
        HibernatePlugIn.closeSession();
      }
      return obj;
    }

    protected void update(Class clazz, Object obj, Integer id) throws Exception {
      Session ses = HibernatePlugIn.openSession();
      try {
        ses.update(obj);
        ses.flush();
        ses.connection().commit();
      } catch (Exception e) {
          log.error(" Error updating object", e);
          ses.connection().rollback();
          throw e;
      } finally {
          HibernatePlugIn.closeSession();
      }
    }

    protected void update(Object obj) throws Exception {
      Session ses = HibernatePlugIn.openSession();
      try {
        ses.update(obj);
        ses.flush();
        ses.connection().commit();
      } catch (Exception e) {
          log.error(" Error updating object", e);
          ses.connection().rollback();
          throw e;
      } finally {
          HibernatePlugIn.closeSession();
      }
    }

    protected void create(Object obj) throws Exception {
      Session ses = HibernatePlugIn.openSession();
      try {
        ses.save(obj);
   
        ses.flush();
        ses.connection().commit();
      } catch (Exception e) {
          log.error(" Error saving object", e);
          ses.connection().rollback();
          throw e;
      } finally {
          HibernatePlugIn.closeSession();
      }
    }
}
