package net.javajigi.user.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import net.javajigi.abs.Constants;
import net.javajigi.abs.action.SignonAction;
import net.javajigi.user.model.UserManager;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/** 
 * @struts.action
 *      path="/user_remove"
 *      scope="request"
 *
 * @struts.action-forward
 *      name="user_list"
 *      path="/user_list.do"
 * 		redirect="true"
 */
public class DeleteAction extends SignonAction{
	private Log log = LogFactory.getLog(net.javajigi.user.action.DeleteAction.class);

	public ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		String userId = request.getParameter("userId");
		
		UserManager manager = UserManager.instance();
		manager.remove(userId);
			
		HttpSession session = request.getSession();
		session.removeAttribute(Constants.USER_KEY);

		if (log.isInfoEnabled()) {	
			log.info("User Logout");
		}
			
		return mapping.findForward("user_list");
	}
}
