package net.javajigi.util;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**

 * DateTime Class 뿹
 *
 *
 * <table>
 * <tr><td>ش</td><td>DateTime.getYear()</td></tr>
 * <tr><td>̹		:DateTime.getMonth()</td></tr>
 * <tr><td>			:DateTime.getDay()</td></tr>
 * <tr><td>			:DateTime.getDayOfWeek()</td></tr>
 * <tr><td>ð		:DateTime.getHour()</td></tr>
 * <tr><td>			:DateTime.getMinute()</td></tr>
 * <tr><td> 			:DateTime.getSecond()</td></tr>
 * <tr><td> ¥		:DateTime.getDateString()</td></tr>
 * <tr><td> ¥		:DateTime.getDateString(".")</td></tr>
 * <tr><td> ¥		:DateTime.getDateString("/")</td></tr>
 * <tr><td>ðƮ		:DateTime.getTimeString()</td></tr>
 * <tr><td>TimeStamp		:DateTime.getTimeStampString()</td></tr>
 * <tr><td>DateTimeMin 	:DateTime.getDate_Time_Min()</td></tr>
 * <tr><td>DateTimeString 	:DateTime.getDateTimeString()</td></tr>
 * <tr><td>Ǵ		:DateTime.checkEmbolism(2002)</td></tr>
 * <tr><td>ϼ ϱ		:DateTime.getMonthDate("2002","2")</td></tr>
 * </table>
 * @author bayard@generationjava.com
 * @version 0.4 20010812
 */

public class DateTime {

	public static String dateSep = "-";
	public static String timeSep = ":";
	public static String dateSep_1 = ".";

	private static final String[] weekDay = { "SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT" };

	public DateTime() {
	}

	/**
	 *
	 * For example, String time = DateTime.getFormatString("yyyy-MM-dd HH:mm:ss");
	 *
	 * @param java.lang.String pattern  "yyyy, MM, dd, HH, mm, ss and more"
	 * @return formatted string representation of current day and time with  your pattern.
	 */
	public static int getNumberByPattern(String pattern) {
		java.text.SimpleDateFormat formatter =
			new java.text.SimpleDateFormat(pattern, java.util.Locale.KOREA);
		String dateString = formatter.format(new java.util.Date());
		return Integer.parseInt(dateString);
	}

	/**
	* 糯¥ ⵵ ϴ Method
	*
	* @param
	* @exception
	* @author
	*/
	public static int getYear() {
		return getNumberByPattern("yyyy");
	}

	/**
	* 糯¥  ϴ Method
	*
	* @param
	* @exception
	* @author
	*/
	public static int getMonth() {
		return getNumberByPattern("MM");
	}

	/**
	* 糯¥ ڸ ϴ Method
	*
	* @param
	* @exception
	* @author
	*/
	public static int getDay() {
		return getNumberByPattern("dd");
	}

	/**
	*   ϴ Method
	*/
	public static String getDayOfWeek() {
		Calendar c = Calendar.getInstance();		
		return weekDay[c.get(java.util.Calendar.DAY_OF_WEEK) - 1];
	}

	/**
	* Ư  ϴ Method
	*/
	public static String getDayOfWeek(int year, int month, int day) throws ParseException {
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		Calendar c = Calendar.getInstance();
		c.setTime( dateFormat.parse(year + "-" + month + "-" + day) );
		
		return weekDay[c.get(java.util.Calendar.DAY_OF_WEEK) - 1];
	}

	/**
	*  ð ð ϴ Method
	*
	* @param
	* @exception
	* @author
	*/
	public static int getHour() {
		Calendar c = Calendar.getInstance();
		return c.get(Calendar.HOUR_OF_DAY);
	}

	/**
	*  ð  ϴ Method
	*
	* @param
	* @exception
	* @author
	*/
	public static int getMinute() {
		Calendar c = Calendar.getInstance();
		return c.get(Calendar.MINUTE);
	}

	/**
	* ð  ϴ Method
	*
	* @param
	* @exception
	* @author
	*/
	public static int getSecond() {
		Calendar c = Calendar.getInstance();
		return c.get(Calendar.SECOND);
	}

	/**
	* YYY-MM-DD  Ʈ ϴ Method
	* @param pattern String
	* @exception
	* @author
	*/
	public static String getDateString() {
		return getYear() + "-" + getMonth() + "-" + getDay();
	}

	/**
	* YYY-MM-DD  Ʈ Pattern  ϴ Method
	* Pattern    ݿ
	* @param pattern String
	* @exception
	* @author
	*/
	public static String getDateString(String pattern) {
		String month = getMonth() + "";
		String day = getDay() + "";

		if (month.length() == 1) {
			month = "0" + month;
		}
		if (day.length() == 1) {
			day = "0" + day;
		}

		return getYear() + pattern + month + pattern + day;
	}

	/**
	* ///// Ʈ ϴ Method
	*
	* @param
	* @exception
	* @author
	*/
	public static String getDateTimeString() {
		String month = getMonth() + "";
		String day = getDay() + "";
		String hour = getHour() + "";
		String min = getMinute() + "";
		String sec = getSecond() + "";

		if (month.length() == 1) {
			month = "0" + month;
		}
		if (day.length() == 1) {
			day = "0" + day;
		}
		if (hour.length() == 1) {
			hour = "0" + hour;
		}
		if (min.length() == 1) {
			min = "0" + min;
		}
		if (sec.length() == 1) {
			sec = "0" + sec;
		}
		return getYear() + "" + month + "" + day + "" + hour + "" + min + sec;
	}

	/**
		* ־ ⵵  ϴ Method
		*
		* @param int year
		* @exception
		* @author
		*/
	public static boolean checkEmbolism(int year) {
		int remain = 0;
		int remain_1 = 0;
		int remain_2 = 0;

		remain = year % 4;
		remain_1 = year % 100;
		remain_2 = year % 400;

		// the ramain is 0 when year is divided by 4;
		if (remain == 0) {
			// the ramain is 0 when year is divided by 100;
			if (remain_1 == 0) {
				// the remain is 0 when year is divided by 400;
				if (remain_2 == 0)
					return true;
				else
					return false;
			} else
				return true;
		}
		return false;
	}
	/**
	* ־ , ϼ ϴ Method
	*
	* @param    String year, String month
	* @exception
	* @author
	*/
	public static int getMonthDate(int year, int month) {
		int[] dateMonth = new int[12];

		dateMonth[0] = 31;
		dateMonth[1] = 28;
		dateMonth[2] = 31;
		dateMonth[3] = 30;
		dateMonth[4] = 31;
		dateMonth[5] = 30;
		dateMonth[6] = 31;
		dateMonth[7] = 31;
		dateMonth[8] = 30;
		dateMonth[9] = 31;
		dateMonth[10] = 30;
		dateMonth[11] = 31;

		if (checkEmbolism(year)) {
			dateMonth[1] = 29;
		}

		int day = dateMonth[month - 1];

		return day;
	}

	public static String getMonthName(int month){
		String[] months = {"1", "2", "3", "4", "5", "6",
			"7", "8", "9", "10", "11", "12"};
		
		return months[month-1];
	}

	/**
	 * 14ڸ( : 20020626142535) ¥ 2002-06-26 ó ȯ.
	 * Insert the method's description here.
	 * Creation date: (2002-06-26  4:40:05)
	 * @param datetime java.lang.String
	 */
	public static String getDecodeDate(String datetime) {
		return datetime.substring(0, 4)
			+ "-"
			+ datetime.substring(4, 6)
			+ "-"
			+ datetime.substring(6, 8);
	}

	public static String getDateFormatDateTime(String datetime) {
		String date = getDecodeDate(datetime);

		int time = Integer.parseInt(datetime.substring(8, 10));

		return date
			+ " "
			+ time
			+ ":"
			+ datetime.substring(10, 12)
			+ ":"
			+ datetime.substring(12);
	}

	public static Date convertStringToDate(String dateTime)
		throws ParseException {
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");

		return dateFormat.parse(getDateFormatDateTime(dateTime));
	}
	
	public static int getFirstOfWeek(int year, int month, int day) throws ParseException {
		DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");

		Calendar c = Calendar.getInstance();
		c.setTime( dateFormat.parse(year + "-" + month + "-" + day) );
		
		return c.get( java.util.Calendar.DAY_OF_WEEK );
	}
}
